
void RawDataDraw(char *run_name)
{

   gROOT->Reset();
   FILE *fp;

   char file_name[30];
   sprintf(file_name,"../raw_data/%s.dat",run_name);

   if ((fp=fopen(file_name,"rb+"))==NULL){
      printf("File open error\n");
      return -1;
   }

   unsigned int  readnum;
   unsigned int  totalread;
   unsigned char rawdata[33000];

   int MagicWord;
   int TYPE;
   unsigned int Length;
   unsigned int EventID;
   int Trailer;

   int hitnum;

   int DataType;
   int board_num;
   int ch_num;
   int stop_ID;
   int stop_ch;
   int data_length;
   int data[1025];
   int time[1025];
   int keyword;
   int status;
   int checksum;
   
   
   
   
   
   
//   while((fread(rawdata,1,4,fp))>0) {

      totalread = 0;

      /* Magic Word Read */
      readnum   = fread(rawdata,1,4,fp);
      MagicWord = (((rawdata[totalread]&0xFF)<<24) + ((rawdata[totalread+1]&0xFF)<<16) + ((rawdata[totalread+2]&0xFF)<<8) + (rawdata[totalread+3]&0xFF));

      if (MagicWord==0x89ABCDEF) {
         printf("Magic Word 0x%x is OK.\n",MagicWord);
      }

      totalread += readnum;

      /* TYPE Read */
      readnum = fread(rawdata+totalread,1,4,fp);
      TYPE    = (((rawdata[totalread]&0xFF)<<24) + ((rawdata[totalread+1]&0xFF)<<16) + ((rawdata[totalread+2]&0xFF)<<8) + (rawdata[totalread+3]&0xFF));

      if (TYPE==0xFF000000) {
         printf("TYPE 0x%x is OK.\n",TYPE);
      }

      totalread += readnum;

      /* Length Read */
      readnum = fread(rawdata+totalread,1,4,fp);
      Length  = (((rawdata[totalread]&0xFF)<<24) + ((rawdata[totalread+1]&0xFF)<<16) + ((rawdata[totalread+2]&0xFF)<<8) + (rawdata[totalread+3]&0xFF));

      printf("Length is %d.\n",Length);

      totalread += readnum;

      /* Length Read */
      readnum = fread(rawdata+totalread,1,4,fp);
      EventID = (((rawdata[totalread]&0xFF)<<24) + ((rawdata[totalread+1]&0xFF)<<16) + ((rawdata[totalread+2]&0xFF)<<8) + (rawdata[totalread+3]&0xFF));

      printf("Event ID is %d.\n",EventID);

      totalread += readnum;

      printf("Total Read (Header) Number is %d.\n",totalread);

      /* Data Packet Read */
      hitnum = Length/2060;
      printf("Hit Channel Number is %d.\n",hitnum);

      for (int i=0; i<hitnum; i++) {

         readnum  = fread(rawdata+totalread,1,2,fp);
         DataType = (((rawdata[totalread]&0xFF)<<8) + (rawdata[totalread+1]&0xFF));
         printf("Data Type : 0x%x\n",DataType);
         totalread += readnum;

         readnum   = fread(rawdata+totalread,1,2,fp);
         board_num = (rawdata[totalread]&0xFF);
         ch_num    = (rawdata[totalread+1]&0xFF);
         printf("Board Number : %d\n",board_num);
         printf("Channel Number : %d\n",ch_num+1);
         totalread += readnum;

         readnum = fread(rawdata+totalread,1,2,fp);
         stop_ID = ((rawdata[totalread]&0xFC)>>2);
         stop_ch = (((rawdata[totalread]&0x03)<<8) + (rawdata[totalread+1]&0xFF));
         printf("Stop ID : %d\n",stop_ID);
         printf("Stop Number : %d\n",stop_ch);
         totalread += readnum;

         readnum     = fread(rawdata+totalread,1,2,fp);
         data_length = (((rawdata[totalread]&0xFF)<<8) + (rawdata[totalread+1]&0xFF));
         printf("Data Length : %d\n",data_length);
         totalread += readnum;

         printf("Total Read (Packet Header) Number is %d.\n",totalread);

         readnum = fread(rawdata+totalread,1,data_length,fp);
         for (int j=0; j<readnum; j=j+2) {
            int n = j/2;
            data[n] = ((rawdata[totalread+j]&0xFF)<<8) + (rawdata[totalread+j+1]&0xFF);
            time[n] = n;
         }
         totalread += readnum;

         readnum = fread(rawdata+totalread,1,2,fp);
         keyword = (((rawdata[totalread]&0xFF)<<8) + (rawdata[totalread+1]&0xFF));
         printf("Key Word : 0x%x\n",keyword);
         totalread += readnum;

         readnum  = fread(rawdata+totalread,1,2,fp);
         status   = (rawdata[totalread]&0xFF);
         checksum = (rawdata[totalread+1]&0xFF);
         printf("Status : 0x%x\n",status);
         printf("Check Sum : 0x%x\n",checksum);
         totalread += readnum;
      }

      /* Trailer Read */
      readnum = fread(rawdata+totalread,1,4,fp);
      Trailer = (((rawdata[totalread]&0xFF)<<24) + ((rawdata[totalread+1]&0xFF)<<16) + ((rawdata[totalread+2]&0xFF)<<8) + (rawdata[totalread+3]&0xFF));

      if (Trailer==0xFEDCBA98) {
         printf("Trailer 0x%x is OK.\n",Trailer);
      }

      totalread += readnum;

      printf("One Event Read : %d\n",totalread);

//   }
   fclose(fp);

/*
   unsigned int data;
   int ch_num;
   int j;
   int k = 0;

   int volt[12500000];
   int time[12500000];

   unsigned int Event_Num;
   unsigned int DRS_Stop_Num;
   unsigned int Stop_ID;

   for (unsigned int i=0; i<readnum; i=i+2) {
      j = i/2;

      if (j%1026==0){
         Event_Num = ((rawdata[i]&0xFF)<<8) + rawdata[i+1];
         printf("Event Number : %d\n",Event_Num);
      } else if (j%1026==1){
         DRS_Stop_Num = ((rawdata[i]&0x03)<<8) + rawdata[i+1];
         Stop_ID      = ((rawdata[i]&0xFC)>>2);
         printf("DRS Stop Channel : %d\n",DRS_Stop_Num);
         printf("DRS Stop ID : %d\n",Stop_ID);
      } else {
         data    = ((rawdata[i]&0x0F)<<8) + rawdata[i+1];
         ch_num  = ((rawdata[i]&0xF0)>>4);
       volt[k] = data;
         time[k] = k;
         
//         printf("%d\n",rawdata[i+1]);

         k = k + 1;
      }

   }

   printf("Channel Number : %d\n",ch_num);

   int np = k;
   printf("np=%d\n",np);
*/

   int np = n+1;
   TCanvas *c1 = new TCanvas("c1","c1",1400,1200);

   c1->cd();
   TGraph *RawGraph = new TGraph(np,time,data);
   RawGraph->SetLineColor(2);
   RawGraph->Draw("AL");

}
